Core - Bug # 59147

Status: Resolved Priority: Must have
Author: Nils Blattner Category: Package Manager
Created: 2014-05-27 Assigned To:

Updated: 2015-05-02 Due date:

TYPO3 Version: 6.2

PHP Version:

Complexity:

Is Regression: No

Sprint Focus: On Location Sprint

Subject: Wrong extension precedence in TYPOS3 6.2

Description

When an extension is installed locally in typo3conf/ext/ it should always take precedence over a system extension from typo3/sysext/.

This was the case in the last LTS and is still documented like that here:

http://docs.typo3.org/TYPO3/CoreApiReference/ExtensionArchitecture/SystemGlobalAndLocalExtensions/Index.html

However in 6.2.3 this is not the case. When | try to install t3skin locally and open the extension manager, it reverts to the system

extension always.

| tracked this behaviour down to typo3/sysext/core/Classes/Package/PackageManager.php.

The reason are lines 85-90. Because they are used to iterate the extension paths, the typo3conf/ext/ path is found first and
typo3/sysext/ last. When the found extension paths are traversed, naturally the latter overwrites the first, leaving the system extension

active always. And since the extension manager aggressively tries to save the PackageStates (which is a good thing), the system

extension is active again after | open the extension manager.

Patch will be attached.

Related issues:

related to Core - Bug # 55646: Framework Packages aren't sorted properly if p...
precedes Core - Bug # 59831: Package loading order is currupted by faulty pat...

Needs Feedbacd014-02-04
Resolved 2014-06-24

Associated revisions

Revision 49b53d49 - 2014-06-22 03:17 - Markus Klein

[BUGFIX] Fix loading order for extensions

Stick to the documented loading order of extensions.
That means following this order: sysext, global, local, composer

The same extension found in the latter will be loaded instead of
the former. Also adjust the Dependency resolver accordingly for the

edge-case of overwriting sysexts.

Resolves: #59147

Releases: 6.3, 6.2

Change-Id: 150c7849e32b309a28f792340f3ff892e516dadb8
Reviewed-on: https://review.typo3.0rg/30449

Reviewed-by: Susanne Moog
Tested-by: Susanne Moog
Reviewed-by: Philipp Gampe
Tested-by: Philipp Gampe

Reviewed-by: Markus Klein

Tested-by: Markus Klein

Revision c0779513 - 2014-06-22 03:18 - Markus Klein

[BUGFIX] Fix loading order for extensions

Stick to the documented loading order of extensions.
That means following this order: sysext, global, local, composer

The same extension found in the latter will be loaded instead of

the former. Also adjust the Dependency resolver accordingly for the

edge-case of overwriting sysexts.

Resolves: #59147

Releases: 6.3, 6.2

Change-Id: 150c7849e32b309a28f792340f3ff892e516dadb8
Reviewed-on: https://review.typo3.org/31021

Reviewed-by: Markus Klein
Tested-by: Markus Klein

Revision 17408213 - 2015-05-02 22:58 - Nicole Cordes

[TASK] Add extension precedence

This patch re-adds the possibility to overwrite system or global
extensions with local ones from typoconf/ext.

Releases: master, 6.2

Resolves: #59147

Change-Id: [11f01677791db26d2be4e70c0a81d96e42ca5147¢
Reviewed-on: http://review.typo3.0rg/39151

Reviewed-by: Markus Klein <markus.klein@typo3.org>

Tested-by: Markus Klein <markus.klein@typo3.org>

Reviewed-by: Helmut Hummel <helmut.hummel@typo3.org>

Tested-by: Helmut Hummel <helmut.hummel@typo3.org>

Revision c¢70f3d8d - 2015-05-02 23:23 - Nicole Cordes

[TASK] Add extension precedence

This patch re-adds the possibility to overwrite system or global
extensions with local ones from typoconf/ext.

Releases: master, 6.2

Resolves: #59147

Change-Id: [11f01677791db26d2be4e70c0a81d96e42ca5147¢
Reviewed-on: http://review.typo3.0rg/39219

Reviewed-by: Markus Klein <markus.klein@typo3.org>

2015-08-04

2/7


https://review.typo3.org/31021
http://review.typo3.org/39151
mailto:markus.klein@typo3.org
mailto:markus.klein@typo3.org
mailto:helmut.hummel@typo3.org
mailto:helmut.hummel@typo3.org
http://review.typo3.org/39219
mailto:markus.klein@typo3.org

Tested-by: Markus Klein <markus.klein@typo3.org>

Revision e9bbe7f2 - 2015-05-14 16:23 - Helmut Hummel

[FOLLOWUP][BUGFIX] Add extension precedence

Before calling TYPO3 package methods, we must ensure

we have the correct instance.

All active composer packages are instance of the Flow package class
which does not implement the methods
isPartOfFactoryDefault or isPartOfMinimalUsableSystem

Resolves: #66955

Related: #59147

Releases: master, 6.2

Change-Id: 15f08cce5e4b0329927d6a302d643f680822e4ad6
Reviewed-on: http:/review.typo3.0rg/39543

Reviewed-by: Nicole Cordes <typo3@cordes.co>
Tested-by: Nicole Cordes <typo3@cordes.co>

Revision 2362c1bc - 2015-05-14 16:25 - Helmut Hummel

[FOLLOWUP][BUGFIX] Add extension precedence

Before calling TYPO3 package methods, we must ensure

we have the correct instance.

All active composer packages are instance of the Flow package class
which does not implement the methods
isPartOfFactoryDefault or isPartOfMinimalUsableSystem

Resolves: #66955

Related: #59147

Releases: master, 6.2

Change-Id: 15f08cce5e4b0329927d6a302d643f680822e4ad6
Reviewed-on: http://review.typo3.0rg/39544

Reviewed-by: Helmut Hummel <helmut.hummel@typo3.org>

Tested-by: Helmut Hummel <helmut.hummel@typo3.org>

History

#1 - 2014-05-27 17:10 - Nils Blattner
- File bug_59147.diff added

#2 - 2014-05-27 17:37 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/30449
#3 - 2014-06-04 12:35 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/30449

#4 - 2014-06-04 12:43 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/30449

#5 - 2014-06-12 12:02 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/30449

#6 - 2014-06-17 20:04 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/30449

#7 - 2014-06-21 15:38 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/30449

#8 - 2014-06-22 03:18 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/31021

#9 - 2014-06-22 03:30 - Markus Klein
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:c0779513b431b19413873893bf630aa3de6fc1fc.

#10 - 2014-06-24 03:10 - Markus Klein
- Status changed from Resolved to Accepted

Patches reverted by #59831.

We need to rethink the solution again, since we need the packagePathStack also when removing extensions, but that information is not persisted,
hence it is missing in this case.
#11 - 2014-07-21 23:56 - Markus Klein
- % Done changed from 100 to 30

#12 - 2014-10-09 17:14 - Caspar Stuebs

Hi all

imo the extension precedence is independent from the other stuff. At this moment only the system extension is respected. If the order is changed, only
the local extension is respected.

The question how to respect the same extension in different places are another bug and should go into another ticket.
Kind Regards.

Caspar

#13 - 2014-11-24 11:53 - Mathias Schreiber

- Assigned To set to Thomas Maroschik

Hey Tom,

get back to me when you're back from vacation, please.

#14 - 2015-04-14 22:13 - Nicole Cordes

- Assigned To deleted (Thomas Maroschik)

- Target version set to 7.3 (Packages)

- Sprint Focus set to On Location Sprint

#15 - 2015-04-14 22:45 - Kasper Ligaard

This issue is a regression, and should be marked as such.

#16 - 2015-05-01 13:29 - Gerrit Code Review

- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39151

#17 - 2015-05-01 13:46 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0org/39151

#18 - 2015-05-01 15:14 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39151

#19 - 2015-05-01 15:56 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/39151

#20 - 2015-05-01 16:01 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/39151

#21 - 2015-05-02 17:53 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/39151

#22 - 2015-05-02 19:26 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/39151

#23 - 2015-05-02 22:23 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/39151

#24 - 2015-05-02 22:48 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/39151

#25 - 2015-05-02 22:51 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/39151

#26 - 2015-05-02 23:00 - Nicole Cordes
- Status changed from Under Review to Resolved
- % Done changed from 30 to 100

Applied in changeset commit:174082131¢c9147be088c36042fba8e68c02c913e.
#27 - 2015-05-02 23:20 - Gerrit Code Review

- Status changed from Resolved to Under Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/39219

#28 - 2015-05-02 23:30 - Nicole Cordes
- Status changed from Under Review to Resolved

Applied in changeset commit:c70f3d8d278489e91d014dd5859381754778bc75.

Files
bug_59147 diff 1 kB 2014-05-27 Nils Blattner
